## soplex 6.0.4+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3.0)

set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS_RELEASE}")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_DEBUG} ${CMAKE_CXX_FLAGS_RELEASE}")

project(SOPLEX
  LANGUAGES CXX)

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
   # require at least gcc 5
   if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
     message(WARNING "GCC version not supported, should be at least 5!")
   endif()
endif()

set(SOPLEX_VERSION_MAJOR 6)
set(SOPLEX_VERSION_MINOR 0)
set(SOPLEX_VERSION_PATCH 4)
set(SOPLEX_VERSION_SUB 0)
set(SOPLEX_VERSION_API 11)


set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/LICENSE")
set(CPACK_PACKAGE_VERSION_MAJOR "${SOPLEX_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${SOPLEX_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${SOPLEX_VERSION_PATCH}")
set(CPACK_PACKAGE_VENDOR "Zuse Institute Berlin")
include(CPack)

option(ZLIB "Use ZLIB" ON)
option(GMP "Use GMP" ON)
option(STATIC_GMP "Prefer static GMP lib" OFF)
option(BOOST "Use Boost (required to build the binary). Disable if you only want to build libsoplex." ON)
option(QUADMATH "should quadmath library be used" OFF)
option(MPFR "Use MPFR" OFF)
option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "Export all symbols into the DLL" ON)
option(MT "use static runtime libraries for Visual Studio compiler" OFF)
option(SANITIZE_ADDRESS "should the address sanitizer be enabled in debug mode if available" OFF)
option(SANITIZE_MEMORY "should the memory sanitizer be enabled in debug mode if available" OFF)
option(SANITIZE_UNDEFINED "should the undefined behavior sanitizer be enabled in debug mode if available" ON)
option(SANITIZE_THREAD "should the thread sanitizer be enabled in debug mode if available" OFF)
option(COVERAGE "enable coverage support" OFF)
option(PAPILO "should papilo library be linked" OFF)

SET(COVERAGE_CTEST_ARGS "" CACHE STRING "additional ctest arguments for coverage")

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

# for colorized output
if(NOT WIN32)
  string(ASCII 27 Esc)
  set(ColourReset "${Esc}[m")
  set(Red         "${Esc}[31m")
endif()

# path to e.g. findGMP module
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

# make 'Release' the default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

# set the correct rpath for OS X
set(CMAKE_MACOSX_RPATH ON)

# use C++14 standard
set(CMAKE_CXX_STANDARD 14)

# set function visibility default to hidden
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

# create a target for updating the current git hash
file(WRITE ${CMAKE_BINARY_DIR}/soplex_update_githash.cmake "
find_program(GIT git)
if(EXISTS \${DST})
   file(STRINGS \${DST} GITHASH_OLD)
   string(REGEX REPLACE \"#define SPX_GITHASH \\\"(.*)\\\"\" \"\\\\1\" GITHASH_OLD \${GITHASH_OLD})
endif()
if((GIT) AND (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/.git))
   execute_process(
      COMMAND \${GIT} describe --always --dirty
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      OUTPUT_VARIABLE GITHASH OUTPUT_STRIP_TRAILING_WHITESPACE)
   string(REGEX REPLACE \"^.*-g\" \"\" GITHASH \${GITHASH})
   if(NOT \${GITHASH} STREQUAL \"\${GITHASH_OLD}\")
      file(WRITE \${DST} \"#define SPX_GITHASH \\\"\${GITHASH}\\\"\n\")
   endif()
else()
   set(GITHASH \${GITHASH_OLD})
   if(NOT GITHASH)
      message(STATUS \"Compiling without git information\")
      set(GITHASH \"NoGitInfo\")
   endif()
   file(WRITE \${DST} \"#define SPX_GITHASH \\\"\${GITHASH}\\\"\n\")
endif()
message(STATUS \"Git hash: \" \${GITHASH})
")
add_custom_target(soplex_update_githash
                  COMMAND ${CMAKE_COMMAND} -DDST=${PROJECT_SOURCE_DIR}/src/soplex/git_hash.cpp
                                           -P ${CMAKE_BINARY_DIR}/soplex_update_githash.cmake)

# write config.h that might have been generated by make
add_custom_target(soplex_cleanup_config ALL
                  COMMAND ${CMAKE_COMMAND} -E remove -f "${PROJECT_SOURCE_DIR}/src/soplex/config.h")

if(NOT "${CMAKE_CXX_COMPILE_FEATURES}" MATCHES "cxx_thread_local")
    add_definitions(-DTHREADLOCAL=)
endif()

# enable coverage support
if(COVERAGE)
    include(CodeCoverage)
    APPEND_COVERAGE_COMPILER_FLAGS()
    set(COVERAGE_EXCLUDES '/usr*')
    SETUP_TARGET_FOR_COVERAGE(NAME coverage
                          EXECUTABLE bash -c "ctest ${COVERAGE_CTEST_ARGS}"
                          DEPENDENCIES soplex)
endif()

if(ZLIB)
    find_package(ZLIB)
endif()
if(ZLIB_FOUND)
    set(SOPLEX_WITH_ZLIB on)
    set(libs ${libs} ${ZLIB_LIBRARIES})
    include_directories(${ZLIB_INCLUDE_DIRS})
endif()

if(GMP)
    find_package(GMP)
endif()
if(GMP_FOUND)
    set(SOPLEX_WITH_GMP on)
    include_directories(${GMP_INCLUDE_DIRS})
    set(libs ${libs} ${GMP_LIBRARIES})
endif()

if(MPFR)
  find_package(MPFR)
endif()
if(MPFR_FOUND)
    message("SoPlex with Boost MPFR libraries.")
    set(SOPLEX_WITH_MPFR on)
    include_directories(${MPFR_INCLUDE_DIRS})
    set(libs ${libs} ${MPFR_LIBRARIES})
else()
    message("-- SoPlex with Boost CPP multiprecision libraries.")
    set(SOPLEX_WITH_CPPMPF on)
endif()

if(QUADMATH)
   find_package(Quadmath)
endif()
if(Quadmath_FOUND)
   set(SOPLEX_WITH_FLOAT128 on)
   include_directories(${Quadmath_INCLUDE_DIRS})
   set(libs ${libs} ${Quadmath_LIBRARY})
else()
   set(QUADMATH_IMPORTED_TARGET "")
endif()

# look for presolvelib PaPILO
if(PAPILO)
    set(PAPILO_MIN_VERSION 2.0.0.0)
    message(STATUS "Finding PAPILO")
    find_package(PAPILO CONFIG ${PAPILO_MIN_VERSION} REQUIRED HINTS ${PAPILO_DIR})
    set(libs ${libs} ${PAPILO_IMPORTED_TARGETS})
    message(STATUS "Finding PAPILO - found")
    set(SOPLEX_WITH_PAPILO on)
else()
    message(STATUS "Support PAPILO: OFF")
    set(PAPILO_IMPORTED_TARGETS "")
    set(SOPLEX_WITH_PAPILO off)
endif()

if(BOOST)
    find_package(Boost 1.65.0) # PaPILO requires at least Boost 1.65 (on mac 1.72)
    if(Boost_FOUND)
        set(SOPLEX_WITH_BOOST on)
        include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
        if(NOT Boost_VERSION_MACRO)
           set(Boost_VERSION_MACRO ${Boost_VERSION})
        endif()
        if(${Boost_VERSION_MACRO} LESS "107000")
            if(NOT SOPLEX_WITH_GMP)
               message(SEND_ERROR "ERROR: ${Red} If no GMP is linked, then the minimal Boost verion is 1.70. ${ColourReset} \
                       Found Boost version is ${Boost_VERSION_STRING}. Either provide newer Boost, link GMP, or disable Boost by setting BOOST=off.")
            else()
               message(WARNING "Warning: ${Red} The multiprecision and quadprecision features are disabled with Boost versions older than 1.70.${ColourReset} \
                       Found Boost version is ${Boost_VERSION_STRING}")
            endif()
        endif()
    else()
        set(BOOST off)
    endif()
endif()

# enable all warnings and explicitly switch on colored output for ninja
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -Wall -Wno-strict-overflow")
    if(CMAKE_GENERATOR STREQUAL "Ninja")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fdiagnostics-color=always")
    endif()
endif()
if(MSVC)
#    add_definitions(/W4)
    add_definitions(/wd4100)
    add_definitions(/wd4661)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    add_compile_options(/bigobj)
    add_definitions(-DBOOST_ALL_NO_LIB)

    # set MT or MTd flag when using the static VS runtime libraries
    if(MT)
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
endif()

# export compilation settings to header file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/soplex/config.h.in ${PROJECT_BINARY_DIR}/soplex/config.h @ONLY)

configure_file(${PROJECT_SOURCE_DIR}/soplex-config.cmake.in "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/soplex-config.cmake" @ONLY)

add_subdirectory(src)
add_subdirectory(tests/c_interface)
add_subdirectory(check)

enable_testing()

=== Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *#
#*                                                                           *#
#*                  This file is part of the class library                   *#
#*       SoPlex --- the Sequential object-oriented simPlex.                  *#
#*                                                                           *#
#*  Copyright (c) 1996-2023 Zuse Institute Berlin (ZIB)                      *#
#*                                                                           *#
#*  Licensed under the Apache License, Version 2.0 (the "License");          *#
#*  you may not use this file except in compliance with the License.         *#
#*  You may obtain a copy of the License at                                  *#
#*                                                                           *#
#*      http://www.apache.org/licenses/LICENSE-2.0                           *#
#*                                                                           *#
#*  Unless required by applicable law or agreed to in writing, software      *#
#*  distributed under the License is distributed on an "AS IS" BASIS,        *#
#*  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. *#
#*  See the License for the specific language governing permissions and      *#
#*  limitations under the License.                                           *#
#*                                                                           *#
#*  You should have received a copy of the Apache-2.0 license                *#
#*  along with SoPlex; see the file LICENSE. If not email soplex@zib.de.     *#
#*                                                                           *#
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *#

#@file    Makefile
#@brief   SoPlex Makefile
#@author  Thorsten Koch
#@author  Ambros Gleixner

#-----------------------------------------------------------------------------
# paths variables
#-----------------------------------------------------------------------------

# define to be able to locate library files
ifeq ($(OSTYPE),mingw)
SPXDIR		=	./
else
SPXDIR		=	$(realpath .)
endif

INSTALLDIR	=

#-----------------------------------------------------------------------------
# detect host architecture
#-----------------------------------------------------------------------------

include make/make.detecthost


#-----------------------------------------------------------------------------
# default settings
#-----------------------------------------------------------------------------

VERSION		:=	6.0.4
SPXGITHASH	=

VERBOSE		=	false
SHARED		=	false
OPT		=	opt
STATICLIBEXT	=	a
SHAREDLIBEXT	=	so
LIBEXT		=	$(STATICLIBEXT)
EXEEXTENSION	=
TEST		=	quick
ALGO		=  1 2 3 4
LIMIT		=  #
SETTINGS	=	default
TIME		=	3600
OUTPUTDIR	=	results
MAKESOFTLINKS	=	true
SOFTLINKS	=
LINKSINFO	=

# these variables are needed for cluster runs
MEM		=	2000
CONTINUE	=	false

# is it allowed to link to external open source libraries?
OPENSOURCE	=	true

GMP      =  true
MPFR     =  false
ZLIB     =  true
BOOST    =  true
QUADMATH =  false

COMP		=	gnu
CXX		=	g++
CXX_c		=	-c # the trailing space is important
CXX_o		=	-o # the trailing space is important
LINKCXX		=	$(CXX)
LINKCXX_L	=	-L
LINKCXX_l	=	-l
LINKCXX_o	=	-o # the trailing space is important
LINKLIBSUFFIX	=
DCXX		=	$(CXX)
LINT		=	flexelint
AR		=	ar
AR_o		=
RANLIB		=	ranlib
DOXY		=	doxygen

READ		=	read -e
LN_s		=	ln -s

LIBBUILD	=	$(AR)
LIBBUILD_o	=	$(AR_o)
LIBBUILDFLAGS	=       $(ARFLAGS)

CPPFLAGS	=	-Isrc
CXXFLAGS	=
BINOFLAGS	=
LIBOFLAGS	=
LDFLAGS		=
ARFLAGS		=	cr
DFLAGS		=	-MM

GMP_LDFLAGS	= 	-lgmp
GMP_CPPFLAGS	=
QUADMATH_LDFLAGS = 	-lquadmath

SOPLEXDIR	=	$(realpath .)
SRCDIR		=	src
BINDIR		=	bin
LIBDIR		=	lib
INCLUDEDIR	=	include
NAME		   =	soplex

LIBOBJ = 	soplex/didxset.o \
				soplex/gzstream.o \
				soplex/idxset.o \
				soplex/mpsinput.o \
				soplex/nameset.o \
				soplex/spxdefines.o \
				soplex/spxgithash.o \
				soplex/spxid.o \
				soplex/spxout.o \
				soplex/usertimer.o \
				soplex/wallclocktimer.o

BINOBJ		=	soplexmain.o
EXAMPLEOBJ	=	example.o
LIBCOBJ		=	soplex_interface.o
REPOSIT		=	# template repository, explicitly empty  #spxproof.o

BASE		=	$(OSTYPE).$(ARCH).$(COMP).$(OPT)

LINKSMARKERFILE	=	$(LIBDIR)/linkscreated.$(OSTYPE).$(ARCH).$(COMP)$(LINKLIBSUFFIX)
LASTSETTINGS	=	$(OBJDIR)/make.lastsettings

SPXGITHASHFILE	=	$(SRCDIR)/soplex/git_hash.cpp
CONFIGFILE = $(SRCDIR)/soplex/config.h

#------------------------------------------------------------------------------
#--- NOTHING TO CHANGE FROM HERE ON -------------------------------------------
#------------------------------------------------------------------------------

GCCWARN		=	-pedantic -Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
			-Wconversion -Wsign-compare -Wshadow \
			-Wredundant-decls -Wdisabled-optimization \
			-Wctor-dtor-privacy -Wnon-virtual-dtor -Wreorder \
			-Woverloaded-virtual -Wsign-promo -Wsynth -Wundef \
			-Wcast-qual \
			-Wmissing-declarations \
			-Wno-unused-parameter -Wno-strict-overflow -Wno-long-long \
		        -Wno-sign-conversion
#			-Wold-style-cast
#			-Weffc++


#-----------------------------------------------------------------------------
include make/make.$(BASE)
-include make/local/make.$(HOSTNAME)
-include make/local/make.$(HOSTNAME).$(COMP)
-include make/local/make.$(HOSTNAME).$(COMP).$(OPT)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# SHARED Libaries
#-----------------------------------------------------------------------------

ifeq ($(SHARED),true)
CPPFLAGS	+=	-fPIC
LIBBUILD	=	$(LINKCXX)
ARFLAGS		=
RANLIB		=
ifeq ($(COMP),msvc)
LIBEXT		=	dll
LIBBUILDFLAGS	+=      -dll
LIBBUILD_o	= 	-out:
else
LIBEXT		=	$(SHAREDLIBEXT)
LIBBUILDFLAGS	+=      -shared
LIBBUILD_o	= 	-o # the trailing space is important
LINKRPATH	=	-Wl,-rpath,
endif
endif

CPPFLAGS	+=	$(USRCPPFLAGS)
CXXFLAGS	+=	$(USRCXXFLAGS)
LDFLAGS		+=	$(USRLDFLAGS)
ARFLAGS		+=	$(USRARFLAGS)
DFLAGS		+=	$(USRDFLAGS)

#-----------------------------------------------------------------------------
# Main Program
#-----------------------------------------------------------------------------

BINNAME		=	$(NAME)-$(VERSION).$(BASE)
EXAMPLENAME	=	example.$(BASE)
LIBNAME		=	$(NAME)-$(VERSION).$(BASE)
BINFILE		=	$(BINDIR)/$(BINNAME)$(EXEEXTENSION)
EXECUTABLE	=	$(BINFILE)
EXAMPLEFILE	=	$(BINDIR)/$(EXAMPLENAME)$(EXEEXTENSION)
LIBFILE		=	$(LIBDIR)/lib$(LIBNAME).$(LIBEXT)
LIBSHORTLINK	=	$(LIBDIR)/lib$(NAME).$(LIBEXT)
LIBLINK		=	$(LIBDIR)/lib$(NAME).$(BASE).$(LIBEXT)

LIBCFILE	=	$(LIBDIR)/lib$(NAME)c-$(VERSION).$(BASE).$(LIBEXT)
LIBCSHORTLINK	=	$(LIBDIR)/lib$(NAME)c.$(LIBEXT)
LIBCLINK	=	$(LIBDIR)/lib$(NAME)c.$(BASE).$(LIBEXT)

BINLINK		=	$(BINDIR)/$(NAME).$(BASE)$(EXEEXTENSION)
BINSHORTLINK	=	$(BINDIR)/$(NAME)$(EXEEXTENSION)
DEPEND		=	src/depend

OBJDIR		=	obj/O.$(BASE)
BINOBJDIR	=	$(OBJDIR)/bin
LIBOBJDIR	=	$(OBJDIR)/lib
LIBOBJSUBDIR = 	$(LIBOBJDIR)/soplex
BINOBJFILES	=	$(addprefix $(BINOBJDIR)/,$(BINOBJ))
EXAMPLEOBJFILES	=	$(addprefix $(BINOBJDIR)/,$(EXAMPLEOBJ))
LIBOBJFILES	=	$(addprefix $(LIBOBJDIR)/,$(LIBOBJ))
LIBCOBJFILES	=	$(addprefix $(LIBOBJDIR)/,$(LIBCOBJ))
BINSRC		=	$(addprefix $(SRCDIR)/,$(BINOBJ:.o=.cpp))
EXAMPLESRC	=	$(addprefix $(SRCDIR)/,$(EXAMPLEOBJ:.o=.cpp))
LIBSRC		=	$(addprefix $(SRCDIR)/,$(LIBOBJ:.o=.cpp))
ALLSRC		=	$(BINSRC) $(EXAMPLESRC) $(LIBSRC)

#-----------------------------------------------------------------------------
# External Libraries
#-----------------------------------------------------------------------------

# check if it is allowed to link to external open source libraries
ifeq ($(OPENSOURCE), false)
	override ZLIB	=	false
	override GMP	=	false
endif

GMPDEP	:=	$(SRCDIR)/depend.gmp
GMPSRC	:=	$(shell cat $(GMPDEP))
ifeq ($(GMP),true)
CPPFLAGS	+= $(GMP_CPPFLAGS)
LDFLAGS	+= $(GMP_LDFLAGS)
else
GMP_LDFLAGS	=
GMP_CPPFLAGS	=
endif

ifeq ($(MPFR),true)
LDFLAGS += -lmpfr
else
# Flags for cpp mpf
endif

# For boost program options
ifeq ($(BOOST),true)
	LDFLAGS += $(BOOST_LDFLAGS)
else
		BOOST_LDFLAGS =
endif

# For quadmath support
ifeq ($(QUADMATH),true)
	LDFLAGS += $(QUADMATH_LDFLAGS)
else
	QUADMATH_LDFLAGS =
endif


ZLIBDEP		:=	$(SRCDIR)/depend.zlib
ZLIBSRC		:=	$(shell cat $(ZLIBDEP))
ifeq ($(ZLIB_LDFLAGS),)
ZLIB		=	false
endif
ifeq ($(ZLIB),true)
FLAGS	+= $(ZLIB_FLAGS)
LDFLAGS		+=	$(ZLIB_LDFLAGS)
else
ZLIB_LDFLAGS	=
ZLIB_FLAGS	=
endif

ifeq ($(GMP),true)
ifeq ($(COMP),msvc)
SOFTLINKS	+=	$(LIBDIR)/mpir.$(ARCH)
SOFTLINKS	+=	$(LIBDIR)/libmpir.$(ARCH).$(OPT).lib
LINKSINFO	+=	"\n  -> \"mpir.$(ARCH)\" is a directory containing the mpir installation, i.e., \"mpir.$(ARCH)/gmp.h\" should exist.\n"
LINKSINFO	+=	" -> \"libmpir.*\" is the path to the MPIR library\n"
endif
endif

ifeq ($(SHARED),true)
EXT_LIBS	= $(ZLIB_LDFLAGS) $(GMP_LDFLAGS) $(BOOST_LDFLAGS) $(QUADMATH_LDFLAGS)
endif


#-----------------------------------------------------------------------------
# Rules
#-----------------------------------------------------------------------------

ifeq ($(VERBOSE),false)
.SILENT:	$(LIBLINK) $(LIBSHORTLINK) $(BINLINK) $(BINSHORTLINK) $(BINFILE) example $(EXAMPLEOBJFILES) $(LIBFILE) $(LIBCFILE) $(BINOBJFILES) $(LIBOBJFILES)
MAKE		+= -s
endif

.PHONY: all
all:		makelibfile
		@$(MAKE) $(BINFILE) $(LIBLINK) $(LIBSHORTLINK) $(BINLINK) $(BINSHORTLINK)

.PHONY: preprocess
preprocess:	checkdefines
ifneq ($(SOFTLINKS),)
		@$(SHELL) -ec 'if test ! -e $(LINKSMARKERFILE) ; \
			then \
				echo "-> generating necessary links" ; \
				$(MAKE) -j1 $(LINKSMARKERFILE) ; \
			fi'
endif
		@$(MAKE) touchexternal

$(LIBLINK) $(LIBSHORTLINK):	$(LIBFILE)
		@rm -f $@
		cd $(dir $@) && $(LN_s) $(notdir $(LIBFILE)) $(notdir $@)

$(LIBCLINK) $(LIBCSHORTLINK):	$(LIBCFILE)
		@rm -f $@
		cd $(dir $@) && $(LN_s) $(notdir $(LIBCFILE)) $(notdir $@)

$(BINLINK) $(BINSHORTLINK):	$(BINFILE)
		@rm -f $@
		cd $(dir $@) && $(LN_s) $(notdir $(BINFILE)) $(notdir $@)

ifeq ($(SHARED),true)
$(BINFILE):	$(LIBFILE) $(BINOBJFILES) | $(BINDIR) $(BINOBJDIR)
		@echo "-> linking $@"
		$(LINKCXX) $(BINOBJFILES) \
		$(LDFLAGS) $(LINKCXX_L)$(LIBDIR) $(LINKRPATH)\$$ORIGIN/../$(LIBDIR) $(LINKCXX_l)$(LIBNAME) $(LINKCXX_o)$@ \
		|| ($(MAKE) errorhints && false)
else
$(BINFILE):	$(LIBOBJFILES) $(BINOBJFILES) | $(BINDIR) $(BINOBJDIR)
		@echo "-> linking $@"
		$(LINKCXX) $(BINOBJFILES) $(LIBOBJFILES) \
		$(LDFLAGS) $(LINKCXX_o)$@ \
		|| ($(MAKE) errorhints && false)
endif

.PHONY: example
example:	$(LIBOBJFILES) $(EXAMPLEOBJFILES) | $(BINDIR) $(EXAMPLEOBJDIR)
		@echo "-> linking $(EXAMPLEFILE)"
		$(LINKCXX) $(EXAMPLEOBJFILES) $(LIBOBJFILES) \
		$(LDFLAGS) $(LINKCXX_o)$(EXAMPLEFILE) \
		|| ($(MAKE) errorhints && false)

.PHONY: makelibfile
makelibfile:	preprocess
		@$(MAKE) $(LIBFILE) $(LIBLINK) $(LIBSHORTLINK)

.PHONY: makelibcfile
makelibcfile: preprocess
		@$(MAKE) $(LIBCFILE) $(LIBCSHAREDLINK) $(LIBCSHORTLINK)

# original library
$(LIBFILE):	$(LIBOBJFILES) | $(LIBDIR) $(LIBOBJDIR)
		@echo "-> generating library $@"
		-rm -f $(LIBFILE)
ifeq ($(SHARED),true)
		$(LIBBUILD) $(LIBBUILDFLAGS) $(LIBBUILD_o)$@ $(LIBOBJFILES) $(REPOSIT) $(LDFLAGS)
else
		$(LIBBUILD) $(LIBBUILDFLAGS) $(LIBBUILD_o)$@ $(LIBOBJFILES) $(REPOSIT)
endif
ifneq ($(RANLIB),)
		$(RANLIB) $@
endif

# C interface
$(LIBCFILE): $(LIBOBJFILES) $(LIBCOBJFILES) | $(LIBDIR) $(LIBOBJDIR)
		@echo "-> generating library $@"
		-rm -f $(LIBCFILE)
ifeq ($(SHARED),true)
		$(LIBBUILD) $(LIBBUILDFLAGS) $(LIBBUILD_o)$@ $(LIBOBJFILES) $(LIBCOBJFILES) $(REPOSIT) $(LDFLAGS)
else
		$(LIBBUILD) $(LIBBUILDFLAGS) $(LIBBUILD_o)$@ $(LIBOBJFILES) $(LIBCOBJFILES) $(REPOSIT)
endif
ifneq ($(RANLIB),)
		$(RANLIB) $@
endif

# include target to detect the current git hash
-include make/local/make.detectgithash

# this empty target is needed for the SoPlex release versions
githash::	# do not remove the double-colon

# include local targets

=== check/CMakeLists.txt ===
include(CTest)

#
# define the set of feasible instances
#
set(successInstances
    "adlittle\;0.22549496316238038228101176621492e6"
    "afiro\;-0.46475314285714285714285714285714e3"
    "agg\;-0.35991767286576506712640824319636e8"
    "beaconfd\;0.335924858072e5"
    "blend\;-0.30812149845828220173774356124984e2"
    "bore3d\;0.13730803942084927215581987251301e4"
    "brandy\;0.15185098964881283835426751550618e4"
    "capri\;0.26900129137681610087717280693754e4"
    "etamacro\;-0.7557152333749133350792583667773e3"
    "finnis\;0.17279106559561159432297900375543e6"
    "grow7\;-0.47787811814711502616766956242865e8"
    "israel\;-0.89664482186304572966200464196045e6"
    "kb2\;-0.17499001299062057129526866493726e4"
    "lotfi\;-0.2526470606188e2"
    "recipe\;-0.266616e3"
    "sc105\;-0.52202061211707248062628010857689e2"
    "sc205\;-0.52202061211707248062628010857689e2"
    "sc50a\;-0.64575077058564509026860413914575e2"
    "sc50b\;-0.7e2"
    "scagr25\;-0.14753433060768523167790925075974e8"
    "scagr7\;-0.2331389824330984e7"
    "scfxm1\;0.18416759028348943683579089143655e5"
    "scorpion\;0.18781248227381066296479411763586e4"
    "scrs8\;0.90429695380079143579923107948844e3"
    "scsd1\;0.86666666743333647292533502995263e1"
    "seba\;0.157116e5"
    "share1b\;-0.7658931857918568112797274346007e5"
    "bgetam\;+infinity"
    "box1\;+infinity"
    "ex72a\;+infinity"
    "forest6\;+infinity"
    "galenet\;+infinity"
    "gams10am\;+infinity"
    "klein1\;+infinity"
    "refinery\;+infinity"
    "woodinfe\;+infinity"
    "gas11\;-infinity"
    )

set(failInstances
    "share2b\;0.123456789e5"
    "shell\;+infinity"
    "vtp-base\;-infinity"
    )

#
# define the set of settings
#
set(settings
    default
    default-col
    default-row
    devex
    internalsimplifier
    papilosimplifier
    polish1
    polish2
    steep
    )

# use GREATER to work with old cmake versions
if(BOOST)
   #need boost to run exact
   set(settings
       ${settings}
       exact)
if(${Boost_VERSION_MACRO} GREATER "106999")
    set(settings
        ${settings}
        mpf)
   if(SOPLEX_HAVE_FLOAT128)
    set(settings
        ${settings}
        quad)
   endif()
endif()
endif()

#
# define a macro to add tests
#
# add_instancetests takes an instance group and a status
# that SoPlex should report as arguments
#
macro(add_instancetests instances solutionstatus)
#
# loop over the instances
#
foreach(instance ${${instances}})
    #
    # loop over all settings
    #
    foreach(setting ${settings})
        #
        # treat the instance as a tuple (list) of two values
        #
        list(GET instance 0 name)
        list(GET instance 1 optval)
        #
        # specify the instance and the settings load command for soplex
        #
        set(inst "${PROJECT_SOURCE_DIR}/check/instances/${name}.mps")
        set(optvalCommand "--extsol=${optval}")
        if(${setting} STREQUAL "default")
            set(loadCommand "")
        else()
            set(loadCommand "--loadset=${PROJECT_SOURCE_DIR}/settings/${setting}.set")
        endif()

        #
        # add a test and test properties
        #
        add_test(NAME ${name}-${setting} COMMAND $<TARGET_FILE:soplex> ${optvalCommand} ${loadCommand} ${inst})
        set_tests_properties (${name}-${setting} PROPERTIES PASS_REGULAR_EXPRESSION "Validation          : ${solutionstatus}")
    endforeach(setting)
endforeach(instance)
endmacro(add_instancetests)

#
# add tests for success and fail instances
#
add_instancetests( successInstances "Success" )
add_instancetests( failInstances "Fail" )

=== src/CMakeLists.txt ===
#
# interface function for setting common library properties
#
function(setLibProperties targetname outputname)
    set_target_properties(${targetname} PROPERTIES
        OUTPUT_NAME ${outputname}
	MACOSX_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
endfunction(setLibProperties)

include(GNUInstallDirs)

include_directories(BEFORE ${CMAKE_CURRENT_SOURCE_DIR})

set(sources
    soplex/didxset.cpp
    soplex/gzstream.cpp
    soplex/idxset.cpp
    soplex/mpsinput.cpp
    soplex/nameset.cpp
    soplex/spxdefines.cpp
    soplex/spxgithash.cpp
    soplex/spxid.cpp
    soplex/spxout.cpp
    soplex/usertimer.cpp
    soplex/wallclocktimer.cpp)

set(headers
    soplex/array.h
    soplex/basevectors.h
    soplex/classarray.h
    soplex/classset.h
    soplex/clufactor.h
    soplex/clufactor_rational.h
    soplex/cring.h
    soplex/dataarray.h
    soplex/datahashtable.h
    soplex/datakey.h
    soplex/dataset.h
    soplex/didxset.h
    soplex/dsvectorbase.h
    soplex/dsvector.h
    soplex/exceptions.h
    soplex/gzstream.h
    soplex/idlist.h
    soplex/idxset.h
    soplex/islist.h
    soplex/lpcolbase.h
    soplex/lpcol.h
    soplex/lpcolsetbase.h
    soplex/lpcolset.h
    soplex/lprowbase.h
    soplex/lprow.h
    soplex/lprowsetbase.h
    soplex/lprowset.h
    soplex/mpsinput.h
    soplex/nameset.h
    soplex/notimer.h
    soplex/random.h
    soplex/rational.h
    soplex/ratrecon.h
    soplex/slinsolver.h
    soplex/slinsolver_rational.h
    soplex/slufactor.h
    soplex/slufactor_rational.h
    soplex/solbase.h
    soplex/sol.h
    soplex/sorter.h
    soplex/spxalloc.h
    soplex/spxautopr.h
    soplex/spxbasis.h
    soplex/spxboundflippingrt.h
    soplex/spxdantzigpr.h
    soplex/spxdefaultrt.h
    soplex/spxdefines.h
    soplex/spxdevexpr.h
    soplex/spxequilisc.h
    soplex/spxfastrt.h
    soplex/spxfileio.h
    soplex/spxgeometsc.h
    soplex/spxgithash.h
    soplex/spxharrisrt.h
    soplex/spxhybridpr.h
    soplex/spxid.h
    soplex/spxleastsqsc.h
    soplex/spxlpbase.h
    soplex/spxlp.h
    soplex/spxmainsm.h
    soplex/spxout.h
    soplex/spxparmultpr.h
    soplex/spxpapilo.h
    soplex/spxpricer.h
    soplex/spxratiotester.h
    soplex/spxscaler.h
    soplex/spxsimplifier.h
    soplex/spxsolver.h
    soplex/spxstarter.h
    soplex/spxsteepexpr.h
    soplex/spxsteeppr.h
    soplex/spxsumst.h
    soplex/spxvectorst.h
    soplex/spxweightpr.h
    soplex/spxweightst.h
    soplex/ssvectorbase.h
    soplex/ssvector.h
    soplex/stablesum.h
    soplex/statistics.h
    soplex/svectorbase.h
    soplex/svector.h
    soplex/svsetbase.h
    soplex/svset.h
    soplex/timerfactory.h
    soplex/timer.h
    soplex/unitvectorbase.h
    soplex/unitvector.h
    soplex/updatevector.h
    soplex/usertimer.h
    soplex/validation.h
    soplex/vectorbase.h
    soplex/vector.h
    soplex/dvector.h
    soplex/wallclocktimer.h
    )

file(GLOB headers
    ${headers}
    soplex/*.hpp
)

if(MSVC)
   set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)
endif()

# create soplex library with pic
add_library(libsoplex-pic STATIC ${sources})
if(MSVC)
    setLibProperties(libsoplex-pic "libsoplex-pic")
else()
   setLibProperties(libsoplex-pic "soplex-pic")
endif()

set_target_properties(libsoplex-pic PROPERTIES
    POSITION_INDEPENDENT_CODE on
    VERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR}.${SOPLEX_VERSION_PATCH}.${SOPLEX_VERSION_SUB}
    SOVERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR})
add_dependencies(libsoplex-pic soplex_update_githash)
target_include_directories(libsoplex-pic PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)
target_link_libraries(libsoplex-pic ${libs})

# create soplex library without pic
add_library(libsoplex STATIC ${sources})
if(MSVC)
    setLibProperties(libsoplex "libsoplex")
else()
   setLibProperties(libsoplex "soplex")
endif()

set_target_properties(libsoplex PROPERTIES
    VERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR}.${SOPLEX_VERSION_PATCH}.${SOPLEX_VERSION_SUB}
    SOVERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR})
add_dependencies(libsoplex soplex_update_githash)
target_include_directories(libsoplex PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)
target_link_libraries(libsoplex ${libs})

# create C shared library
add_library(libsoplexshared SHARED soplex_interface.cpp ${sources})
if(MSVC)
    setLibProperties(libsoplexshared "libsoplexshared")
else()
   setLibProperties(libsoplexshared "soplexshared")
endif()

set_target_properties(libsoplexshared PROPERTIES
    VERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR}.${SOPLEX_VERSION_PATCH}.${SOPLEX_VERSION_SUB}
    SOVERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR})
add_dependencies(libsoplexshared soplex_update_githash libsoplex)
if(MSVC)
    target_compile_options(libsoplexshared PUBLIC "/Zc:__cplusplus")
    setLibProperties(libsoplexshared "libsoplexshared")
endif()
target_include_directories(libsoplexshared PUBLIC
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:include>)
target_link_libraries(libsoplexshared libsoplex ${libs})
set_target_properties(libsoplexshared PROPERTIES CXX_VISIBILITY_PRESET default)

# create soplex binary using library without pic
add_executable(soplex soplexmain.cpp)
target_link_libraries(soplex LINK_PUBLIC libsoplex ${Boost_LIBRARIES})

if(CMAKE_BUILD_TYPE EQUAL "Debug")
   find_package(Sanitizers)
   add_sanitizers(soplex)
endif()

add_executable(example EXCLUDE_FROM_ALL example.cpp)
target_link_libraries(example libsoplex)

# set the install rpath to the installed destination
set_target_properties(soplex PROPERTIES INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

# install the header files of soplex
install(FILES ${headers} ${PROJECT_BINARY_DIR}/soplex/config.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/soplex)
install(FILES soplex.h soplex.hpp soplex_interface.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# install the binary and the library to appropriate lcoations and add them to an export group
install(TARGETS soplex libsoplex libsoplex-pic libsoplexshared EXPORT soplex-targets
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Add library targets to the build-tree export set
export(TARGETS libsoplex libsoplex-pic libsoplexshared
  FILE "${CMAKE_BINARY_DIR}/soplex-targets.cmake")

#configure the config file for the build tree
set(CONF_INCLUDE_DIRS "${PROJECT_SOURCE_DIR}/src" "${PROJECT_BINARY_DIR}")
configure_file(${PROJECT_SOURCE_DIR}/soplex-config.cmake.in
  "${CMAKE_BINARY_DIR}/soplex-config.cmake" @ONLY)

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
${CMAKE_BINARY_DIR}/soplex-config-version.cmake
    VERSION ${SOPLEX_VERSION_MAJOR}.${SOPLEX_VERSION_MINOR}.${SOPLEX_VERSION_PATCH}
    COMPATIBILITY SameMajorVersion
    )


#configure the config file for the install
set(CONF_INCLUDE_DIRS "\${CMAKE_CURRENT_LIST_DIR}/../../../include")
configure_file(${PROJECT_SOURCE_DIR}/soplex-config.cmake.in
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/soplex-config.cmake" @ONLY)

# install the targets of the soplex export group and the config file so that other projects
# can link easily against soplex
install(EXPORT soplex-targets FILE soplex-targets.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/soplex)
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/soplex-config.cmake"
	           ${CMAKE_BINARY_DIR}/soplex-config-version.cmake
		   DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/soplex)

## soplex 6.0.3+dfsg

=== debian/changelog ===
soplex (6.0.3+dfsg-2) unstable; urgency=medium

  * Source only upload.
  * Add missing dependencies to -dev package

 -- Timo Röhling <roehling@debian.org>  Mon, 18 Dec 2023 23:13:40 +0100

soplex (6.0.3+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1056619)

 -- Timo Röhling <roehling@debian.org>  Sat, 25 Nov 2023 20:33:44 +0100

=== debian/control ===
Source: soplex
Section: math
Priority: optional
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libgmp-dev,
 zlib1g-dev,
Homepage: https://github.com/scipopt/soplex
Standards-Version: 4.6.2
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/math-team/soplex.git
Vcs-Browser: https://salsa.debian.org/math-team/soplex
Description: sequential object-oriented simplex solver
 This package is part of the SCIP Optimization Suite. SoPlex is an optimization
 package for solving linear programming problems (LPs) based on an advanced
 implementation of the primal and dual revised simplex algorithm. It provides
 special support for the exact solution of LPs with rational input data.

Package: soplex
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides the standalone solver which can read MPS or LP format
 files.

Package: libsoplex-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libboost-dev,
 libgmp-dev,
 libsoplexshared6.0 (= ${binary:Version}),
Description: ${source:Synopsis} (development files)
 ${source:Extended-Description}
 .
 This package provides the necessary files to develop and link against the
 SoPlex library.

Package: libsoplexshared6.0
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (shared library)
 ${source:Extended-Description}
 .
 This package provides the SoPlex shared library.

## soplex 6.0.4+dfsg

=== debian/changelog ===
soplex (6.0.4+dfsg-1.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:47:53 +1100

soplex (6.0.4+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062912

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:04:09 +0000

soplex (6.0.4+dfsg-1) unstable; urgency=medium

  * New upstream version 6.0.4+dfsg
  * Bump copyright years in d/copyright
  * Update patches
    - Drop 0001-Fix-Multi-Arch-install-location.patch (obsolete)
    - Add 0001-Do-not-mess-with-RPATH.patch

 -- Timo Röhling <roehling@debian.org>  Sat, 30 Dec 2023 23:25:06 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: soplex
 Section: math
 Priority: optional
-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Timo Röhling <roehling@debian.org>
-Build-Depends:
+Build-Depends: dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  libboost-dev,
@@ -39,14 +40,17 @@
  ${misc:Depends},
  libboost-dev,
  libgmp-dev,
- libsoplexshared6.0 (= ${binary:Version}),
+ libsoplexshared6.0t64 (= ${binary:Version}),
 Description: ${source:Synopsis} (development files)
  ${source:Extended-Description}
  .
  This package provides the necessary files to develop and link against the
  SoPlex library.
 
-Package: libsoplexshared6.0
+Package: libsoplexshared6.0t64
+Provides: ${t64:Provides}
+Replaces: libsoplexshared6.0
+Breaks: libsoplexshared6.0 (<< ${source:Version})
 Section: libs
 Architecture: any
 Multi-Arch: same

=== debian/watch ===
version=4
opts=searchmode=plain,filenamemangle=s%(?:.*?/)?v?@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,uversionmangle=s%(\d)(\d)(\d)%$1.$2.$3%,dversionmangle=auto,oversionmangle=s%$%+dfsg%,repack \
 https://api.github.com/repos/scipopt/soplex/tags \
 tarball/(?:[^"]*?/)?[a-z]*@ANY_VERSION@

## soplex 7.0.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.3.0)
+cmake_minimum_required(VERSION 3.9)
 
 set(CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_DEBUG} ${CMAKE_C_FLAGS_RELEASE}")
 set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_DEBUG} ${CMAKE_CXX_FLAGS_RELEASE}")
@@ -6,17 +6,9 @@
 project(SOPLEX
   LANGUAGES CXX)
 
-if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
-   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
-   # require at least gcc 5
-   if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
-     message(WARNING "GCC version not supported, should be at least 5!")
-   endif()
-endif()
-
-set(SOPLEX_VERSION_MAJOR 6)
+set(SOPLEX_VERSION_MAJOR 7)
 set(SOPLEX_VERSION_MINOR 0)
-set(SOPLEX_VERSION_PATCH 4)
+set(SOPLEX_VERSION_PATCH 1)
 set(SOPLEX_VERSION_SUB 0)
 set(SOPLEX_VERSION_API 11)
 
@@ -30,10 +22,11 @@
 
 option(ZLIB "Use ZLIB" ON)
 option(GMP "Use GMP" ON)
+option(EMSCRIPTEN_HTML "Emscripten HTML output" OFF)
 option(STATIC_GMP "Prefer static GMP lib" OFF)
 option(BOOST "Use Boost (required to build the binary). Disable if you only want to build libsoplex." ON)
 option(QUADMATH "should quadmath library be used" OFF)
-option(MPFR "Use MPFR" OFF)
+option(MPFR "Use MPFR" ON)
 option(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS "Export all symbols into the DLL" ON)
 option(MT "use static runtime libraries for Visual Studio compiler" OFF)
 option(SANITIZE_ADDRESS "should the address sanitizer be enabled in debug mode if available" OFF)
@@ -41,7 +34,7 @@
 option(SANITIZE_UNDEFINED "should the undefined behavior sanitizer be enabled in debug mode if available" ON)
 option(SANITIZE_THREAD "should the thread sanitizer be enabled in debug mode if available" OFF)
 option(COVERAGE "enable coverage support" OFF)
-option(PAPILO "should papilo library be linked" OFF)
+option(PAPILO "should papilo library be linked" ON)
 
 SET(COVERAGE_CTEST_ARGS "" CACHE STRING "additional ctest arguments for coverage")
 
@@ -140,19 +133,6 @@
     set(libs ${libs} ${GMP_LIBRARIES})
 endif()
 
-if(MPFR)
-  find_package(MPFR)
-endif()
-if(MPFR_FOUND)
-    message("SoPlex with Boost MPFR libraries.")
-    set(SOPLEX_WITH_MPFR on)
-    include_directories(${MPFR_INCLUDE_DIRS})
-    set(libs ${libs} ${MPFR_LIBRARIES})
-else()
-    message("-- SoPlex with Boost CPP multiprecision libraries.")
-    set(SOPLEX_WITH_CPPMPF on)
-endif()
-
 if(QUADMATH)
    find_package(Quadmath)
 endif()
@@ -166,11 +146,13 @@
 
 # look for presolvelib PaPILO
 if(PAPILO)
+    message(STATUS "Finding PAPILO")
     set(PAPILO_MIN_VERSION 2.0.0.0)
-    message(STATUS "Finding PAPILO")
-    find_package(PAPILO CONFIG ${PAPILO_MIN_VERSION} REQUIRED HINTS ${PAPILO_DIR})
+    find_package(PAPILO CONFIG ${PAPILO_MIN_VERSION} HINTS ${PAPILO_DIR})
+endif()
+if(PAPILO_FOUND)
+    message(STATUS "Finding PAPILO - found")
     set(libs ${libs} ${PAPILO_IMPORTED_TARGETS})
-    message(STATUS "Finding PAPILO - found")
     set(SOPLEX_WITH_PAPILO on)
 else()
     message(STATUS "Support PAPILO: OFF")
@@ -178,8 +160,9 @@
     set(SOPLEX_WITH_PAPILO off)
 endif()
 
+set(BOOST_MINIMUM_VERSION 1.65.0)
 if(BOOST)
-    find_package(Boost 1.65.0) # PaPILO requires at least Boost 1.65 (on mac 1.72)
+    find_package(Boost ${BOOST_MINIMUM_VERSION}) # PaPILO requires at least Boost 1.65 (on mac 1.72)
     if(Boost_FOUND)
         set(SOPLEX_WITH_BOOST on)
         include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
@@ -195,9 +178,46 @@
                        Found Boost version is ${Boost_VERSION_STRING}")
             endif()
         endif()
+        if(MPFR) # MPFR is used within boost multiprecision, so using it without Boost does not make sense
+            find_package(MPFR)
+        endif()
+        if(MPFR_FOUND)
+            message("SoPlex with Boost MPFR libraries.")
+            set(SOPLEX_WITH_MPFR on)
+            include_directories(${MPFR_INCLUDE_DIRS})
+            set(libs ${libs} ${MPFR_LIBRARIES})
+        else()
+            message("-- SoPlex with Boost CPP multiprecision libraries.")
+            set(SOPLEX_WITH_CPPMPF on)
+        endif()
     else()
         set(BOOST off)
     endif()
+endif()
+
+# disable fused floating point contraction to enhance reproducibility across compilers and architectures
+if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
+    add_compile_options(/fp:precise /bigobj)
+    add_definitions(/wd4100)
+    add_definitions(/wd4661)
+    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
+    add_definitions(-DBOOST_ALL_NO_LIB)
+    # set MT or MTd flag when using the static VS runtime libraries
+    if(MT)
+        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
+        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
+    endif()
+elseif(CMAKE_CXX_COMPILER_ID MATCHES "Intel")
+    add_compile_options(-fp-model=precise)
+elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
+    # require at least gcc 5
+    if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 5)
+        message(WARNING "GCC version not supported, should be at least 5!")
+    endif()
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
+    add_compile_options(-ffp-contract=off)
+elseif(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+    add_compile_options(-ffp-contract=off)
 endif()
 
 # enable all warnings and explicitly switch on colored output for ninja
@@ -207,24 +227,6 @@
         set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -fdiagnostics-color=always")
     endif()
 endif()
-if(MSVC)
-#    add_definitions(/W4)
-    add_definitions(/wd4100)
-    add_definitions(/wd4661)
-    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
-    add_compile_options(/bigobj)
-    add_definitions(-DBOOST_ALL_NO_LIB)
-
-    # set MT or MTd flag when using the static VS runtime libraries
-    if(MT)
-        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /MT")
-        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} /MTd")
-    endif()
-endif()
-
-if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
-   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-psabi")
-endif()
 
 # export compilation settings to header file
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/soplex/config.h.in ${PROJECT_BINARY_DIR}/soplex/config.h @ONLY)

=== Makefile ===
--- 
+++ 
@@ -51,7 +51,7 @@
 # default settings
 #-----------------------------------------------------------------------------
 
-VERSION		:=	6.0.4
+VERSION		:=	7.0.1.0
 SPXGITHASH	=
 
 VERBOSE		=	false
@@ -67,6 +67,7 @@
 SETTINGS	=	default
 TIME		=	3600
 OUTPUTDIR	=	results
+SEEDS		=	0
 MAKESOFTLINKS	=	true
 SOFTLINKS	=
 LINKSINFO	=
@@ -158,7 +159,7 @@
 GCCWARN		=	-pedantic -Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
 			-Wconversion -Wsign-compare -Wshadow \
 			-Wredundant-decls -Wdisabled-optimization \
-			-Wctor-dtor-privacy -Wnon-virtual-dtor -Wreorder \
+			-Wnon-virtual-dtor -Wreorder \
 			-Woverloaded-virtual -Wsign-promo -Wsynth -Wundef \
 			-Wcast-qual \
 			-Wmissing-declarations \

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -119,6 +119,7 @@
     soplex/vector.h
     soplex/dvector.h
     soplex/wallclocktimer.h
+    soplex/fmt.hpp
     )
 
 file(GLOB headers
@@ -194,6 +195,11 @@
 add_executable(soplex soplexmain.cpp)
 target_link_libraries(soplex LINK_PUBLIC libsoplex ${Boost_LIBRARIES})
 
+if(EMSCRIPTEN AND EMSCRIPTEN_HTML)
+    set_target_properties(soplex PROPERTIES LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/soplex_webdemo_shell.html)
+    set(CMAKE_EXECUTABLE_SUFFIX ".html")
+endif()
+
 if(CMAKE_BUILD_TYPE EQUAL "Debug")
    find_package(Sanitizers)
    add_sanitizers(soplex)
@@ -208,6 +214,21 @@
 # install the header files of soplex
 install(FILES ${headers} ${PROJECT_BINARY_DIR}/soplex/config.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/soplex)
 install(FILES soplex.h soplex.hpp soplex_interface.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+
+install(FILES
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/chrono.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/color.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/compile.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/core.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/format-inl.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/format.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/locale.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/os.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/ostream.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/posix.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/printf.h
+     ${PROJECT_SOURCE_DIR}/src/soplex/external/fmt/ranges.h
+ DESTINATION include/soplex/external/fmt)
 
 # install the binary and the library to appropriate lcoations and add them to an export group
 install(TARGETS soplex libsoplex libsoplex-pic libsoplexshared EXPORT soplex-targets

=== debian/changelog ===
soplex (7.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version 7.0.1+dfsg
  * Update patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 17 May 2024 10:40:21 +0200

soplex (7.0.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sun, 14 Apr 2024 22:40:07 +0200

soplex (7.0.0+dfsg-1) experimental; urgency=medium

  * Exclude vendored copy of fmt
  * New upstream version 7.0.0+dfsg
  * Bump Standards-Version to 4.7.0
  * Bump SONAME to 7.0
  * Devendor fmt library

 -- Timo Röhling <roehling@debian.org>  Fri, 12 Apr 2024 21:15:59 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: soplex
 Section: math
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Math Team <team+math@tracker.debian.org>
+Maintainer: Debian Math Team <team+math@tracker.debian.org>
 Uploaders: Timo Röhling <roehling@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5),
+Build-Depends:
+ dpkg-dev (>= 1.22.5),
  debhelper-compat (= 13),
  cmake,
  libboost-dev,
+ libfmt-dev,
  libgmp-dev,
  zlib1g-dev,
 Homepage: https://github.com/scipopt/soplex
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/math-team/soplex.git
 Vcs-Browser: https://salsa.debian.org/math-team/soplex
@@ -39,18 +40,17 @@
 Depends:
  ${misc:Depends},
  libboost-dev,
+ libfmt-dev,
  libgmp-dev,
- libsoplexshared6.0t64 (= ${binary:Version}),
+ libsoplexshared7.0 (= ${binary:Version}),
 Description: ${source:Synopsis} (development files)
  ${source:Extended-Description}
  .
  This package provides the necessary files to develop and link against the
  SoPlex library.
 
-Package: libsoplexshared6.0t64
+Package: libsoplexshared7.0
 Provides: ${t64:Provides}
-Replaces: libsoplexshared6.0
-Breaks: libsoplexshared6.0 (<< ${source:Version})
 Section: libs
 Architecture: any
 Multi-Arch: same

## soplex 7.1.0+dfsg

=== debian/changelog ===
soplex (7.1.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Tue, 03 Sep 2024 16:47:13 +0200

soplex (7.1.0+dfsg-1) experimental; urgency=medium

  * Keep vendored zstr
  * New upstream version 7.1.0+dfsg
  * Refresh patches (no functional changes)
  * Update d/copyright
  * Bump SOVERSION to 7.1

 -- Timo Röhling <roehling@debian.org>  Fri, 30 Aug 2024 14:21:56 +0200

=== debian/control ===
--- 
+++ 
@@ -42,15 +42,14 @@
  libboost-dev,
  libfmt-dev,
  libgmp-dev,
- libsoplexshared7.0 (= ${binary:Version}),
+ libsoplexshared7.1 (= ${binary:Version}),
 Description: ${source:Synopsis} (development files)
  ${source:Extended-Description}
  .
  This package provides the necessary files to develop and link against the
  SoPlex library.
 
-Package: libsoplexshared7.0
-Provides: ${t64:Provides}
+Package: libsoplexshared7.1
 Section: libs
 Architecture: any
 Multi-Arch: same
